#ifndef ARGUMENTS_HPP
#define ARGUMENTS_HPP

/* __ Includes ___________________________________________________________ */
struct args5 {
    int arg1;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
};
struct args15 {
    int arg1;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
    int arg6;
    int arg7;
    int arg8;
    int arg9;
    int arg10;
    int arg11;
    int arg12;
    int arg13;
    int arg14;
    int arg15;
};

/* __ ArgCopy5 class _____________________________________________________ */
class ArgCopy5 {
public:
    ArgCopy5(int arg1,
             int arg2,
             int arg3,
             int arg4,
             int arg5) :
             m_arg1(arg1),
             m_arg2(arg2),
             m_arg3(arg3),
             m_arg4(arg4),
             m_arg5(arg5) { }
    double eval(void) { return (m_arg1+m_arg2+m_arg3+m_arg4+m_arg5); }
protected:
    int m_arg1;
    int m_arg2;
    int m_arg3;
    int m_arg4;
    int m_arg5;
};


/* __ ArgCopy15 class ____________________________________________________ */
class ArgCopy15 {
public:
    ArgCopy15(int arg1,
              int arg2,
              int arg3,
              int arg4,
              int arg5,
              int arg6,
              int arg7,
              int arg8,
              int arg9,
              int arg10,
              int arg11,
              int arg12,
              int arg13,
              int arg14,
              int arg15) :
              m_arg1(arg1),
              m_arg2(arg2),
              m_arg3(arg3),
              m_arg4(arg4),
              m_arg5(arg5),
              m_arg6(arg6),
              m_arg7(arg7),
              m_arg8(arg8),
              m_arg9(arg9),
              m_arg10(arg10),
              m_arg11(arg11),
              m_arg12(arg12),
              m_arg13(arg13),
              m_arg14(arg14),
              m_arg15(arg15) { }
    double eval(void) { return (m_arg1+m_arg2+m_arg3+m_arg4+m_arg5+
                                m_arg6+m_arg7+m_arg8+m_arg9+m_arg10+
                                m_arg11+m_arg12+m_arg13+m_arg14+m_arg15); }
protected:
    int m_arg1;
    int m_arg2;
    int m_arg3;
    int m_arg4;
    int m_arg5;
    int m_arg6;
    int m_arg7;
    int m_arg8;
    int m_arg9;
    int m_arg10;
    int m_arg11;
    int m_arg12;
    int m_arg13;
    int m_arg14;
    int m_arg15;
};


/* __ ArgRef5 class ______________________________________________________ */
class ArgRef5 {
public:
    ArgRef5(const int& arg1,
            const int& arg2,
            const int& arg3,
            const int& arg4,
            const int& arg5) :
            m_arg1(arg1),
            m_arg2(arg2),
            m_arg3(arg3),
            m_arg4(arg4),
            m_arg5(arg5) { }
    double eval(void) { return (m_arg1+m_arg2+m_arg3+m_arg4+m_arg5); }
protected:
    const int& m_arg1;
    const int& m_arg2;
    const int& m_arg3;
    const int& m_arg4;
    const int& m_arg5;
};


/* __ ArgRef15 class _____________________________________________________ */
class ArgRef15 {
public:
    ArgRef15(const int& arg1,
             const int& arg2,
             const int& arg3,
             const int& arg4,
             const int& arg5,
             const int& arg6,
             const int& arg7,
             const int& arg8,
             const int& arg9,
             const int& arg10,
             const int& arg11,
             const int& arg12,
             const int& arg13,
             const int& arg14,
             const int& arg15) :
             m_arg1(arg1),
             m_arg2(arg2),
             m_arg3(arg3),
             m_arg4(arg4),
             m_arg5(arg5),
             m_arg6(arg6),
             m_arg7(arg7),
             m_arg8(arg8),
             m_arg9(arg9),
             m_arg10(arg10),
             m_arg11(arg11),
             m_arg12(arg12),
             m_arg13(arg13),
             m_arg14(arg14),
             m_arg15(arg15) { }
    double eval(void) { return (m_arg1+m_arg2+m_arg3+m_arg4+m_arg5+
                                m_arg6+m_arg7+m_arg8+m_arg9+m_arg10+
                                m_arg11+m_arg12+m_arg13+m_arg14+m_arg15); }
protected:
    const int& m_arg1;
    const int& m_arg2;
    const int& m_arg3;
    const int& m_arg4;
    const int& m_arg5;
    const int& m_arg6;
    const int& m_arg7;
    const int& m_arg8;
    const int& m_arg9;
    const int& m_arg10;
    const int& m_arg11;
    const int& m_arg12;
    const int& m_arg13;
    const int& m_arg14;
    const int& m_arg15;
};


/* __ ArgStruct5 class ___________________________________________________ */
class ArgStruct5 {
public:
    ArgStruct5(const args5& args) :
               m_args(args) { }
    double eval(void) { return (m_args.arg1+
                                m_args.arg2+
                                m_args.arg3+
                                m_args.arg4+
                                m_args.arg5); }
protected:
    const args5& m_args;
};


/* __ ArgStruct15 class __________________________________________________ */
class ArgStruct15 {
public:
    ArgStruct15(const args15& args) :
                m_args(args) { }
    double eval(void) { return (m_args.arg1+
                                m_args.arg2+
                                m_args.arg3+
                                m_args.arg4+
                                m_args.arg5+
                                m_args.arg6+
                                m_args.arg7+
                                m_args.arg8+
                                m_args.arg9+
                                m_args.arg10+
                                m_args.arg11+
                                m_args.arg12+
                                m_args.arg13+
                                m_args.arg14+
                                m_args.arg15); }
protected:
    const args15& m_args;
};

#endif